'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (_ref) {
  var values = _ref.values,
      rules = _ref.rules,
      _ref$errors = _ref.errors,
      errors = _ref$errors === undefined ? [] : _ref$errors,
      setErrors = _ref.setErrors,
      valuesBlurred = _ref.valuesBlurred;

  var newErrors = Object.keys(rules).filter(function (rule) {
    if (errors.filter(function (error) {
      return error.name === rule;
    }).length) return true;
    if (valuesBlurred) return valuesBlurred[rule];

    return true;
  }).map(function (field) {
    return rules[field].map(function (rule) {
      var error = rule((0, _get2.default)(values, field), values);

      if (!error) return false;

      return {
        name: field,
        message: error
      };
    });
  }).reduce(function (acc, row) {
    return [].concat(_toConsumableArray(acc), _toConsumableArray(row));
  }, []).filter(Boolean);

  setErrors(newErrors);
  return newErrors;
};